oracle.pg.text

## Interface OracleAutoIndex<T extends Element>

- All Superinterfaces:
    Index<T>, OracleIndex<T>
  All Known Implementing Classes:
    LuceneAutoIndex, LuceneEdgeAutoIndex, LuceneVertexAutoIndex, NoSQLLuceneEdgeAutoIndex, NoSQLLuceneVertexAutoIndex, NoSQLSolrEdgeAutoIndex, NoSQLSolrVertexAutoIndex, SolrAutoIndex, SolrEdgeAutoIndex, SolrVertexAutoIndex

      public interface OracleAutoIndex<T extends Element>
      extends OracleIndex<T>

  An interface that extends the functions defined in OracleIndex to provide manage an automatic index.

- - ### Field Summary

    - ### Fields inherited from interface oracle.pg.text.OracleIndex

      `EDGE_ID_PROP, EDGE_LABEL_PROP, END_NODE_ID_PROP, START_NODE_ID_PROP, TYPE_DT_BOOL, TYPE_DT_DATE, TYPE_DT_DOUBLE, TYPE_DT_FLOAT, TYPE_DT_INTEGER, TYPE_DT_SERIALIZABLE, TYPE_DT_STRING, VERTEX_ID_PROP`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeConnectionsArray()` Closes the associated connection array used to load vertices/edges in parallel from the underlying graph.
    `boolean` | `containsIndexedKey(String key)` Verifies if the given key is already indexed using this automatic index.
    `CloseableIterable<T>` | `get(String key, Object value, boolean acceptWildcard)` Gets all the elements matching the specified K/V property within the index
    `Object[]` | `getConnectionsArray()` Gets the connection array used to load vertices/edges in parallel from the underlying graph.
    `Iterable<T>` | `getElementsFromPG()` Gets an Iterable<T> of elements from the associated property graph.
    `Iterable<T>` | `getElementsFromPG(String key)` Gets an Iterable<T> of elements from the associated property graph, matching the specified key.
    `Iterable<T>` | `getElementsFromPG(String[] keys)` Gets an Iterable<T> of elements from the associated property graph, matching any of the specified keys.
    `Iterable<T>[]` | `getElementsFromPG(String[] keys, Object[] conns, int startSplitID)` Gets an array of `CloseableIterable` objects that hold all the elements with an attribute matching any of the given key property names.
    `Set<String>` | `getIndexedKeys()` Get the keys associated to this auto index.
    `int` | `getPartitionsNumber()` Gets the number of partitions (or splits) of the element's table for the associated property graph.
    `void` | `indexElements()` Index elements in a property graph with respect to the current indexed keys.
    `void` | `indexElementsPartitioned()` Index elements in a property graph with respect to the current indexed keys using getElementsPartitioned APIs.
    `List<String>` | `loadIndexedKeys()` Gets a list of all the indexed keys used for this automatic index.
    `void` | `reindexElements()` Re-index the elements of the associated property graph based on the current indexed keys.
    `void` | `reindexElements(String key)` Re-index the elements of the associated property graph based on the specified key.
    `void` | `reindexElements(String[] indexedKeys)` Re-index the elements of the associated property graph based on the specified keys using getElementsPartitioned APIs.
    `void` | `reindexElementsNoPartitioned(String[] indexedKeys)` Re-index the elements of the associated property graph based on the specified keys.
    `void` | `reindexElementsPartitioned()` Re-index the elements of the associated property graph based on the current indexed keys using getElementsPartitioned APIs.
    `void` | `reindexElementsPartitioned(String key)` Re-index the elements of the associated property graph based on the specified key using getElementsPartitioned APIs.
    `void` | `reindexElementsPartitioned(String[] indexedKeys)` Re-index all elements over a partitioned graph.

    - ### Methods inherited from interface oracle.pg.text.OracleIndex

      `add, buildSearchTerm, buildSearchTerm, clearIndex, close, commit, count, count, dropIndex, get, getDirectoryName, getDocIdentifier, getGraphName, getIndexClass, getOracleIndexParameters, getParameters, getPartitioned, getPartitioned, getTotalShards, isDelBatchEmpty, isDelBatchFull, isUpdatesBatchEmpty, isUpdatesBatchFull, query, refreshIndex, remove, removeAll`

    - ### Methods inherited from interface com.tinkerpop.blueprints.Index

      `count, get, getIndexName, put, query, remove`

- - ### Method Detail

    - #### closeConnectionsArray

          void closeConnectionsArray()

      Closes the associated connection array used to load vertices/edges in parallel from the underlying graph.

    - #### containsIndexedKey

          boolean containsIndexedKey(String key)

      Verifies if the given key is already indexed using this automatic index.

    - #### get

          CloseableIterable<T> get(String key,
                                 Object value,
                                 boolean acceptWildcard)

      Gets all the elements matching the specified K/V property within the index
      Specified by:
        `get` in interface `OracleIndex<T extends Element>`
      Parameters:
        `key` - the key of the K/V property
        `value` - the value object of the K/V property
        `acceptWildcard` - specifies if wild cards can be used in the value object.
      Returns:
        a `CloseableIterable` object.

    - #### getConnectionsArray

          Object[] getConnectionsArray()
                                       throws Exception

      Gets the connection array used to load vertices/edges in parallel from the underlying graph.
      Returns:
        an array of connections to the database where the property graph instance relies.
      Throws:
        `Exception`

    - #### getElementsFromPG

          Iterable<T> getElementsFromPG()

      Gets an Iterable<T> of elements from the associated property graph.
      Returns:
        an Iterable<T> object.

    - #### getElementsFromPG

          Iterable<T> getElementsFromPG(String key)

      Gets an Iterable<T> of elements from the associated property graph, matching the specified key.
      Parameters:
        `key` - name of the property. It can be NULL which implies all vertices in the graph will be returned.
      Returns:
        an Iterable<T> object.

    - #### getElementsFromPG

          Iterable<T> getElementsFromPG(String[] keys)

      Gets an Iterable<T> of elements from the associated property graph, matching any of the specified keys.
      Parameters:
        `keys` - an array of property key names. It can be NULL which implies all vertices in the graph will be returned.
      Returns:
        an Iterable<T> object.

    - #### getElementsFromPG

          Iterable<T>[] getElementsFromPG(String[] keys,
                                        Object[] conns,
                                        int startSplitID)

      Gets an array of `CloseableIterable` objects that hold all the elements with an attribute matching any of the given key property names. Each element in the `CloseableIterable` array uses a separate connection provided to fetch a subset of the results from a corresponding OraclePropertyGraph instance. Note that we assign an integer ID (in the range of [0, N - 1]) to all the splits of a vertex or edge table with N splits. The subset of splits queried will consist of those shards with ID value in the range of [startSplitID, startSplitID - 1 + size of connections array].
      Parameters:
        `keys` - an array of property key names. It can be NULL which implies all vertices in the graph will be returned.
        `conns` - an array of Object connections to the database where the property graph relies.
        `startSplitID` - the start split ID used to query the property graph.
      Returns:
        an Iterable<T> object.

    - #### getIndexedKeys

          Set<String> getIndexedKeys()

      Get the keys associated to this auto index.
      Returns:
        the set of keys used in this index.

    - #### getPartitionsNumber

          int getPartitionsNumber()

      Gets the number of partitions (or splits) of the element's table for the associated property graph.
      Returns:
        the number of partitions (or splits) of the element's table.

    - #### indexElements

          void indexElements()

      Index elements in a property graph with respect to the current indexed keys.

    - #### indexElementsPartitioned

          void indexElementsPartitioned()

      Index elements in a property graph with respect to the current indexed keys using getElementsPartitioned APIs.

    - #### loadIndexedKeys

          List<String> loadIndexedKeys()

      Gets a list of all the indexed keys used for this automatic index.

    - #### reindexElements

          void reindexElements()

      Re-index the elements of the associated property graph based on the current indexed keys.

    - #### reindexElements

          void reindexElements(String key)

      Re-index the elements of the associated property graph based on the specified key.
      Parameters:
        `key` - the key to use for re-indexing.

    - #### reindexElements

          void reindexElements(String[] indexedKeys)

      Re-index the elements of the associated property graph based on the specified keys using getElementsPartitioned APIs.
      Parameters:
        `indexedKeys` - an array of the indexed keys to use for re-indexing.

    - #### reindexElementsNoPartitioned

          void reindexElementsNoPartitioned(String[] indexedKeys)

      Re-index the elements of the associated property graph based on the specified keys.
      Parameters:
        `indexedKeys` - an array of the indexed keys to use for re-indexing.

    - #### reindexElementsPartitioned

          void reindexElementsPartitioned()

      Re-index the elements of the associated property graph based on the current indexed keys using getElementsPartitioned APIs.

    - #### reindexElementsPartitioned

          void reindexElementsPartitioned(String key)

      Re-index the elements of the associated property graph based on the specified key using getElementsPartitioned APIs.
      Parameters:
        `key` - the key to use for re-indexing.

    - #### reindexElementsPartitioned

          void reindexElementsPartitioned(String[] indexedKeys)

      Re-index all elements over a partitioned graph.
      Parameters:
        `indexedKeys` - an array of keys to be indexed

Copyright © 2015 Oracle and/or its afflilates. All Rights Reserved.